
var listFile = new File( app.preferencesFolder + "/" + "OpenClose_FileList.txt" );
listFile.open("r");
var contents = listFile.read();
listFile.close();
var rows = processInputFile(contents);
if (rows.length>0) {
    var file = new File(rows[0]);
    open(file);
    //delete first line
    listFile.open("w");
    for (var i=1;i<rows.length;i++) {
        listFile.writeln(rows[i]);
    }
    listFile.close();
}

function processInputFile(contents) {
    try {
        // Returns: Array [row][column]
        var c = ""; // Character at index.
        var index = 0;
        var maxIndex = contents.length - 1;
        var result = []; // Array of rows.
        var row = []; // Array of columns.
        var rowSum = 0; // Count of row contents.
        var v = ""; // Column value.
        while (index < contents.length) {
            c = contents[index];
            if (c == "\n" || c == "\r") {
                // Reached end of line.
                // Test for CRLF.
                if (c == "\r" && index < maxIndex) {
                    if (contents[index + 1] == "\n") {
                        // Skip trailing newline.
                        index++;
                    }
                }
                // Column and row complete.
                row.push(v);
                rowSum += v.length;
                if (rowSum) {
                    // Add row only when it has content.
                    result.push(row);
                }
                v = "";
                row = [];
                rowSum = 0;
            } 
            else {
                // Add character to column value.
                v += c;
                //alert(c);
            }

            if (index == maxIndex) {
                // Reached end of data; flush.
                row.push(v);
                rowSum += v.length;
                if (rowSum) {
                    // Add row only when it has content.
                    result.push(row);
                }
                break;
            }
            index++;
        }
        return result;
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}
