
function createExportDialog() {

    try {

        var defaultPath="";
        var jpgPath="";
        try {
            settingsObj = app.getCustomOptions (GUID);
            if (settingsObj != undefined) {
                defaultPath = settingsObj.getString(s2t('key1'));
                jpgPath = settingsObj.getString (s2t('key2'));
            }
        } 
        catch (e) {}

        //Check screen size
        var screenWidth = $.screens[0].right;

        // DIALOG
        // ======
        var fileList;

        var exportDialog = new Window("dialog");
        exportDialog.preferredSize = [screenWidth*.4,screenWidth*.1];
        exportDialog.text = "Export PSD to JPEG";
        exportDialog.orientation = "column";
        exportDialog.alignChildren = ["center", "top"];
        exportDialog.spacing = 10;
        exportDialog.margins = 16;
        exportDialog.resizeable = false;

        // PANEL1
        // ======
        var panel1 = exportDialog.add("panel", undefined, undefined, { name: "panel1" });
        panel1.orientation = "column";
        panel1.alignChildren = ["left", "top"];
        panel1.spacing = 10;
        panel1.margins = 10;

        var statictext1 = panel1.add("statictext", undefined, undefined, { name: "statictext1" });
        statictext1.text = "Please select the PSD files";

        // GROUP1
        // ======
        var group1 = panel1.add("group", undefined, { name: "group1" });
        group1.orientation = "row";
        group1.alignChildren = ["left", "center"];
        group1.spacing = 10;
        group1.margins = 0;

        var edittext1 = group1.add('edittext {properties: {name: "edittext1"}}'); 
                edittext1.helpTip = "Please select the PSD files"; 
                edittext1.preferredSize.width = screenWidth*.3; 

        var button1 = group1.add("button", undefined, undefined, {name: "button1"}); 
            button1.text = "Select ...";
            button1.onClick = function() {
                if (defaultPath!="") {
                    var defaultFolder = new Folder (defaultPath);
                    if ($.os.search(/windows/i) != -1) {
                        fileList = defaultFolder.openDlg ("Please select the PSD files" , '*.psd', true);
                    }
                    else {
                        fileList = defaultFolder.openDlg("Please select the PSD files", getFiles, true)
                    };
                }
                else {
                    if ($.os.search(/windows/i) != -1) {
                        fileList = File.openDialog ("Please select the PSD files" , '*.psd', true);
                    }
                    else {
                        fileList = File.openDialog("Please select the PSD files", getFiles, true)
                    };
                }
                var fileNames=[];
                for (var i=0;i<fileList.length;i++) {
                    // fileNames[i]=fileList[i].displayName;
                    fileNames[i]=fileList[i].name;
                }
                edittext1.text=fileNames;
            }

            function getFiles(theFile) {
                if (theFile.name.match(/\.(psd)$/i) || theFile.constructor.name == "File") {
                    return true
                };
            };

        // PANEL1
        // ======
        var statictext2 = panel1.add("statictext", undefined, undefined, { name: "statictext2" });
        statictext2.text = "Please select JPG folder";

        // GROUP2
        // ======
        var group2 = panel1.add("group", undefined, { name: "group2" });
        group2.orientation = "row";
        group2.alignChildren = ["left", "center"];
        group2.spacing = 10;
        group2.margins = 0;

        var edittext2 = group2.add('edittext {properties: {name: "edittext2"}}');
        edittext2.helpTip = "Please select the folder where the JPG files will be saved";
        edittext2.preferredSize.width = screenWidth*.3;

        var button2 = group2.add("button", undefined, undefined, { name: "button2" });
        button2.text = "Browse ...";
        edittext2.text = jpgPath;
        button2.onClick = function () {
            var testFolder = new Folder(edittext2.text);
            if (!testFolder.exists) {
                var jpgFolder = Folder.selectDialog("Please select the JPG folder");
                if (jpgFolder != null) {
                    edittext2.text = jpgFolder.fsName;
                }
            }
            else {
                var jpgFolder = Folder(testFolder).selectDlg("Please select the JPG folder");
                edittext2.text = jpgFolder.fsName;
            }
        }

        // PANEL2
        // ======
        var panel2 = exportDialog.add("panel", undefined, undefined, { name: "panel2" });
        panel2.orientation = "column";
        panel2.alignChildren = ["left", "top"];
        panel2.spacing = 10;
        panel2.margins = 10;

        // GROUP3
        // ======
        var group3 = panel2.add("group", undefined, { name: "group3" });
        group3.orientation = "row";
        group3.alignChildren = ["left", "center"];
        group3.spacing = 10;
        group3.margins = 0;

        var button3 = group3.add("button", undefined, undefined, { name: "button3" });
        button3.text = "Start";

        button3.onClick = function () {
            if (edittext1.text.length==0) {
                alert("Please select the PSD files");
                return;
            }
            if (edittext2.text.length==0) {
                alert("Please select the JPG folder");
                return;
            }
            var testFolder1 = new Folder(edittext2.text);
            if (!testFolder1.exists) {
                alert("JPG folder doesn't exist");
                return;
            }
            if (!isFolderWritable(testFolder1)) {
                alert ("The program cannot write into JPG folder");
                return;
            }
            var path=File(fileList[0]).parent.fsName;
            var myValue1 = path;
            var myValue2 = edittext2.text;                
            settingsObj.putString (s2t('key1'), myValue1);
            settingsObj.putString (s2t('key2'), myValue2);
            app.putCustomOptions (GUID, settingsObj, true);

            exportDialog.close();
            exportPSD(fileList, edittext2.text);
        }

        var button4 = group3.add("button", undefined, undefined, { name: "button4" });
        button4.text = "Cancel";

        // exportDialog.show();
        exportDialog.center();
        return exportDialog;
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}

function exportPDFDialog() {
    try {
        //Check screen size
        var screenWidth = $.screens[0].right;

        // PDFDIALOG
        // =========
        var pdfDialog = new Window("dialog");
        pdfDialog.preferredSize = [screenWidth*.2,screenWidth*.05];
        pdfDialog.text = "Export as PDF"; 
        pdfDialog.orientation = "column"; 
        pdfDialog.alignChildren = ["center","center"]; 
        pdfDialog.spacing = 10; 
        pdfDialog.margins = 16;
        pdfDialog.resizeable = false; 

        var statictext1 = pdfDialog.add("statictext", undefined, undefined, {name: "statictext1"}); 
        statictext1.text = "Do you want to export as PDF?"; 

        // GROUP1
        // ======
        var group1 = pdfDialog.add("group", undefined, {name: "group1"}); 
        group1.orientation = "row"; 
        group1.alignChildren = ["left","center"]; 
        group1.spacing = 10; 
        group1.margins = 0; 

        var button1 = group1.add("button", undefined, undefined, {name: "button1"}); 
        button1.text = "Yes";
        button1.onClick = function () {
            pdfDialog.close(1);
        }

        var button2 = group1.add("button", undefined, undefined, {name: "button2"}); 
        button2.text = "No"; 
        button2.onClick = function () {
            pdfDialog.close(0);
        }

        // pdfDialog.show();
        pdfDialog.center();
        return pdfDialog;
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}

function showDialog(myDialog) {
    return myDialog.show();
}

s2t = stringIDToTypeID;
var settingsObj = new ActionDescriptor;
var GUID = 'd63dbfcc-509c-41ed-989a-2ba0d26a49a3';

main()

function main() {
    try {
        var numberArray = version.split(".");
        if ( numberArray[0] < 9 ) {
            alert( "You must use Photoshop CS 2 or later to run this script!" );
            // throw( "You must use Photoshop CS 2 or later to run this script!" );
            return;
        }

        var expDialog = createExportDialog();
        showDialog(expDialog);
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}

function exportPSD(psdFileList, jpgFolderText) {
    try {
        var jpgFolder = new Folder(jpgFolderText);
        // alert(psdFolder);
        // alert(jpgFolder);

        if (!jpgFolder.exists) {
            jpgFolder.create();
        }

        if (psdFileList.length > 0) {
            //Sort the psdFileList
            psdFileList.sort(function (a, b) {
                if (app.compareWithNumbers) {
                    return app.compareWithNumbers(a.name, b.name);
                } else {
                    return sortAlphaNum(a.name, b.name);
                }
            });
            for (var index1 = 0; index1 < psdFileList.length; index1++) {
                open(psdFileList[index1]);
                var thedoc = app.activeDocument;
                var docName = thedoc.name;
                var basename = docName.match(/(.*)\.[^\.]+$/)[1];
                // alert(basename);
                var jpegOptions = new JPEGSaveOptions();
                jpegOptions.quality = 12;
                jpegOptions.embedColorProfile = true;
                jpegOptions.matte = MatteType.NONE;
                jpegOptions.scans = 3;
                thedoc.saveAs((new File(jpgFolder.fsName + "/" + basename + ".jpg")), jpegOptions, true);
                thedoc.close();
            }

            var pdfDialog = exportPDFDialog();
            if (showDialog(pdfDialog) == 1) {

                //20% resize
                var smallFolder = new Folder(jpgFolder + '/Small');
                if (!smallFolder.exists) {
                    smallFolder.create();
                }

                function jpgFilter(file) {
                    return (file instanceof File && /\.(jpg)$/i.test(file.name))
                }
                var jpgFileList = jpgFolder.getFiles(jpgFilter);

                if (jpgFileList.length > 0) {
                    //Sort the jpgFileList
                    jpgFileList.sort(function (a, b) {
                        if (app.compareWithNumbers) {
                            return app.compareWithNumbers(a.name, b.name);
                        } else {
                            return sortAlphaNum(a.name, b.name);
                        }
                    });

                    for (var index2 = 0; index2 < jpgFileList.length; index2++) {
                        open(jpgFileList[index2]);
                        var thedoc = app.activeDocument;
                        var docName = thedoc.name;
                        var basename = docName.match(/(.*)\.[^\.]+$/)[1];
                        var jpegOptions = new JPEGSaveOptions();
                        jpegOptions.quality = 8;
                        jpegOptions.embedColorProfile = true;
                        jpegOptions.matte = MatteType.NONE;
                        jpegOptions.scans = 3;
                        thedoc.resizeImage(thedoc.width * .20, thedoc.height * .20, 200, ResampleMethod.BICUBIC, 0);
                        thedoc.saveAs((new File(jpgFolder.fsName + "/Small/" + basename + ".jpg")), jpegOptions, true);
                        thedoc.close(SaveOptions.DONOTSAVECHANGES);

                    }
                }

                function smallFilter(file) {
                    return (file instanceof File && /\.(jpg)$/i.test(file.name))
                }
                var smallFileList = smallFolder.getFiles(smallFilter);
                if (smallFileList.length > 0) {
                    //Sort the smallFileList
                    smallFileList.sort(function (a, b) {
                        if (app.compareWithNumbers) {
                            return app.compareWithNumbers(a.name, b.name);
                        } else {
                            return sortAlphaNum(a.name, b.name);
                        }
                    });

                    //Create the pdf
                    var outputFile = File(jpgFolder.fsName + "/Small/Album.pdf"); 
                    
                    app.makePDFPresentation(smallFileList, outputFile, presentationOptions()); 

                    alert("PDF file saved to: \n" + outputFile.fsName); 
                }
            }
        }
        else {
            return 0;
        }
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}

function sortAlphaNum(a, b) {
    try {
        var reA = /[^a-zA-Z]/g;
        var reN = /[^0-9]/g;
        var AInt = parseInt(a, 10);
        var BInt = parseInt(b, 10);

        if (isNaN(AInt) && isNaN(BInt)) {
            var aA = a.replace(reA, "");
            var bA = b.replace(reA, "");
            if (aA === bA) {
                var aN = parseInt(a.replace(reN, ""), 10);
                var bN = parseInt(b.replace(reN, ""), 10);
                return aN === bN ? 0 : aN > bN ? 1 : -1;
            } else {
                return aA > bA ? 1 : -1;
            }
        } else if (isNaN(AInt)) {
            return 1;
        } else if (isNaN(BInt)) {
            return -1;
        } else {
            return AInt > BInt ? 1 : -1;
        }
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}

function presentationOptions() {
    try {
        var options = new PresentationOptions();
        options.PDFFileOptions = pdfSaveOptions();
        options.presentation = false;
        
        return options;
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}

//This function is copied from https://www.marspremedia.com/software/photoshop/images-to-pdf
//Many thanks to the original author William Campbell 
function pdfSaveOptions() {
    try {
        var options = new PDFSaveOptions();

        // Set properties using values enabled below.

        // options.PDFCompatibility = PDFCompatibility.PDF13;
        // options.PDFCompatibility = PDFCompatibility.PDF14;
        // options.PDFCompatibility = PDFCompatibility.PDF15;
        // options.PDFCompatibility = PDFCompatibility.PDF16;
        // options.PDFCompatibility = PDFCompatibility.PDF17;
        options.PDFCompatibility = PDFCompatibility.PDF17;

        options.PDFStandard = PDFStandard.NONE;
        // options.PDFStandard = PDFStandard.PDFX1A2001;
        // options.PDFStandard = PDFStandard.PDFX1A2003;
        // options.PDFStandard = PDFStandard.PDFX32002;
        // options.PDFStandard = PDFStandard.PDFX32003;
        // options.PDFStandard = PDFStandard.PDFX42008;

        options.colorConversion = true; // convert to destinationProfile
        options.description = ""; // description of the save options in use
        options.destinationProfile = "sRGB IEC61966-2.1";

        // options.downSample = PDFResample.NONE;
        // options.downSample = PDFResample.PDFAVERAGE;
        // options.downSample = PDFResample.PDFSUBSAMPLE;
        options.downSample = PDFResample.PDFBICUBIC;

        options.downSampleSize = 150; // pixels per inch desired
        options.downSampleSizeLimit = 150; // only images pixels per inch greater than this value
        options.embedColorProfile = false;
        options.embedThumbnail = true;

        // options.encoding = PDFEncoding.NONE;
        // options.encoding = PDFEncoding.PDFZIP;
        options.encoding = PDFEncoding.JPEG;
        // options.encoding = PDFEncoding.PDFZIP4BIT;
        // options.encoding = PDFEncoding.JPEGHIGH;
        // options.encoding = PDFEncoding.JPEGMEDHIGH;
        // options.encoding = PDFEncoding.JPEGMED;
        // options.encoding = PDFEncoding.JPEGMEDLOW;
        // options.encoding = PDFEncoding.JPEGLOW;
        // options.encoding = PDFEncoding.JPEG2000HIGH;
        // options.encoding = PDFEncoding.JPEG2000MEDHIGH;
        // options.encoding = PDFEncoding.JPEG2000MED;
        // options.encoding = PDFEncoding.JPEG2000MEDLOW;
        // options.encoding = PDFEncoding.JPEG2000LOW;
        // options.encoding = PDFEncoding.JPEG2000LOSSLESS;

        options.jpegQuality = 6; // range 0 to 12
        options.optimizeForWeb = true;
        // options.tileSize = null; // integer value JPEG2000 compression only

        // These properties set either way.
        options.alphaChannels = false;
        options.annotations = false;
        options.convertToEightBit = true;
        options.layers = false;
        options.preserveEditing = false; // true retains Photoshop data
        options.spotColors = false;
        options.view = false; // true opens PDF in Acrobat after saving it
        return options;
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}

function isFolderWritable( inFolder ) {
    try {
        var isWritable = false;
        var f = File( inFolder + "/deleteme.txt" );
        if ( f.open( "w", "TEXT", "????" ) ) {
            if ( f.write( "delete me" ) ) {
                if ( f.close() ) {
                    if ( f.remove() ) {
                        isWritable = true;
                    }
                }
            }
        }
        return isWritable;
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}
