
function createOpenDialog() {
    try {
        var defaultPath="";
        try {
            settingsObj = app.getCustomOptions (GUID);
            if (settingsObj != undefined) {
                defaultPath = settingsObj.getString(s2t('key1'));
            }
        } 
        catch (e) {}

        //Check screen size
        var screenWidth = $.screens[0].right;

        // DIALOG
        // ======
        var fileList;
        
        var openDialog = new Window("dialog");
            openDialog.preferredSize = [screenWidth*.4,screenWidth*.1];  
            openDialog.text = "Sequential Image Open"; 
            openDialog.orientation = "column"; 
            openDialog.alignChildren = ["center","top"]; 
            openDialog.spacing = 10; 
            openDialog.margins = 16;
            openDialog.resizeable = false; 

        // PANEL1
        // ======
        var panel1 = openDialog.add("panel", undefined, undefined, {name: "panel1"}); 
            panel1.orientation = "column"; 
            panel1.alignChildren = ["left","top"]; 
            panel1.spacing = 10; 
            panel1.margins = 10; 

        var statictext1 = panel1.add("statictext", undefined, undefined, {name: "statictext1"}); 
            statictext1.text = "Please select the images"; 

        // GROUP1
        // ======
        var group1 = panel1.add("group", undefined, {name: "group1"}); 
            group1.orientation = "row"; 
            group1.alignChildren = ["left","center"]; 
            group1.spacing = 10; 
            group1.margins = 0; 

        var edittext1 = group1.add('edittext {properties: {name: "edittext1"}}'); 
            edittext1.helpTip = "Please select the image files"; 
            edittext1.preferredSize.width = screenWidth*.3; 

        var button1 = group1.add("button", undefined, undefined, {name: "button1"}); 
            button1.text = "Select ...";
            button1.onClick = function() {
                if (defaultPath!="") {
                    var defaultFolder = new Folder (defaultPath);
                    if ($.os.search(/windows/i) != -1) {
                        fileList = defaultFolder.openDlg ("Please select the image files" , '*.psd;*.jpg;*.jpeg;*.tif;*.png;*.bmp', true);
                    }
                    else {
                        fileList = defaultFolder.openDlg("Please select the image files", getFiles, true)
                    };
                }
                else {
                    if ($.os.search(/windows/i) != -1) {
                        fileList = File.openDialog ("Please select the image files" , '*.psd;*.jpg;*.jpeg;*.tif;*.png;*.bmp', true);
                    }
                    else {
                        fileList = File.openDialog("Please select the image files", getFiles, true)
                    };
                }
                var fileNames=[];
                for (var i=0;i<fileList.length;i++) {
                    // fileNames[i]=fileList[i].displayName
                    fileNames[i]=fileList[i].name;
                }
                edittext1.text=fileNames;
            }

            function getFiles(theFile) {
                if (theFile.name.match(/\.(jpg|jpeg|tif|psd|png|bmp)$/i) || theFile.constructor.name == "File") {
                    return true
                };
            };

        // PANEL2
        // ======
        var panel2 = openDialog.add("panel", undefined, undefined, {name: "panel2"}); 
            panel2.orientation = "column"; 
            panel2.alignChildren = ["left","top"]; 
            panel2.spacing = 10; 
            panel2.margins = 10; 

        // GROUP2
        // ======
        var group2 = panel2.add("group", undefined, {name: "group2"}); 
            group2.orientation = "row"; 
            group2.alignChildren = ["left","center"]; 
            group2.spacing = 10; 
            group2.margins = 0; 

        var button2 = group2.add("button", undefined, undefined, {name: "button2"}); 
            button2.text = "Start";
            button2.onClick = function () {
                if (edittext1.text.length==0) {
                    alert("Please select the image files");
                    return;
                }
                var path=File(fileList[0]).parent.fsName;
                var myValue1 = path;            
                settingsObj.putString (s2t('key1'), myValue1);
                app.putCustomOptions (GUID, settingsObj, true);
                openDialog.close();
                createListFile(fileList);
            }
        

        var button3 = group2.add("button", undefined, undefined, {name: "button3"}); 
            button3.text = "Cancel"; 

        // openDialog.show();
        openDialog.center();
        return openDialog;
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}

function showDialog(myDialog) {
    return myDialog.show();
}

s2t = stringIDToTypeID;
var settingsObj = new ActionDescriptor;
var GUID = 'eca5621d-18a8-42d4-93bf-809c04ca5809';

main()

function main() {
    var openDialog = createOpenDialog();
    showDialog(openDialog);
}


function createListFile(fileList) {
    try {
        if (fileList.length > 0) {
            //Sort the fileList
            fileList.sort(function (a, b) {
                if (app.compareWithNumbers) {
                    return app.compareWithNumbers(a.name, b.name);
                } else {
                    return sortAlphaNum(a.name, b.name);
                }
            });

            var listFile = new File( app.preferencesFolder + "/" + "OpenClose_FileList.txt" );
            listFile.open("a");
            
            for (var index1 = 1; index1 < fileList.length; index1++) {
                listFile.writeln(fileList[index1]);
            }
            listFile.close();

            //Open the first file 
            open(fileList[0]);
        }
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}

function sortAlphaNum(a, b) {
    try {
        var reA = /[^a-zA-Z]/g;
        var reN = /[^0-9]/g;
        var AInt = parseInt(a, 10);
        var BInt = parseInt(b, 10);

        if (isNaN(AInt) && isNaN(BInt)) {
            var aA = a.replace(reA, "");
            var bA = b.replace(reA, "");
            if (aA === bA) {
                var aN = parseInt(a.replace(reN, ""), 10);
                var bN = parseInt(b.replace(reN, ""), 10);
                return aN === bN ? 0 : aN > bN ? 1 : -1;
            } else {
                return aA > bA ? 1 : -1;
            }
        } else if (isNaN(AInt)) {
            return 1;
        } else if (isNaN(BInt)) {
            return -1;
        } else {
            return AInt > BInt ? 1 : -1;
        }
    }
    catch(e) {
        alert(e + ': Line ' + e.line);
    }
}
